/*
 * JBoss, Home of Professional Open Source.
 * See the COPYRIGHT.txt file distributed with this work for information
 * regarding copyright ownership.  Some portions may be licensed
 * to Red Hat, Inc. under one or more contributor license agreements.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 * Modified by
 * @author  Data Virtuality GmbH
 * @date    $Date$
 *
 */

package org.teiid.translator.jdbc;

import org.teiid.language.Function;

import java.util.ArrayList;
import java.util.List;


/**
 *
 * @author Matias Szaingurten
 * @date 2024.02.22
 *
 */
public class LogFunctionModifier extends FunctionModifier {
    // The base to use
    protected Double base;

    public LogFunctionModifier() {
        this( null);
    }

    public LogFunctionModifier(Double base) {
        this.base = base;
    }

    @Override
    public List<?> translate(Function function) {
        List<Object> objs = new ArrayList<>();

        objs.add("LOG(");
        objs.add(base == null ? "e()" : base);
        objs.add(", "); //$NON-NLS-1$
        objs.add(function.getParameters().get(0));
        objs.add(")"); //$NON-NLS-1$

        return objs;
    }
}
